// Code generated by ent, DO NOT EDIT.

package migrate

import (
	"entgo.io/ent/dialect/sql/schema"
	"entgo.io/ent/schema/field"
)

var (
	// ChatsColumns holds the columns for the "chats" table.
	ChatsColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt, Increment: true},
		{Name: "text", Type: field.TypeString},
		{Name: "attachment", Type: field.TypeString, Nullable: true},
		{Name: "attachment_type", Type: field.TypeString, Nullable: true},
		{Name: "frontend_uuid", Type: field.TypeString, Unique: true},
		{Name: "created_at", Type: field.TypeTime},
		{Name: "updated_at", Type: field.TypeTime},
		{Name: "deleted_at", Type: field.TypeTime, Nullable: true},
		{Name: "reply_to", Type: field.TypeInt, Nullable: true},
		{Name: "chat_room_chats", Type: field.TypeInt},
		{Name: "profile_chats", Type: field.TypeInt},
	}
	// ChatsTable holds the schema information for the "chats" table.
	ChatsTable = &schema.Table{
		Name:       "chats",
		Columns:    ChatsColumns,
		PrimaryKey: []*schema.Column{ChatsColumns[0]},
		ForeignKeys: []*schema.ForeignKey{
			{
				Symbol:     "chats_chats_replies",
				Columns:    []*schema.Column{ChatsColumns[8]},
				RefColumns: []*schema.Column{ChatsColumns[0]},
				OnDelete:   schema.SetNull,
			},
			{
				Symbol:     "chats_chat_rooms_chats",
				Columns:    []*schema.Column{ChatsColumns[9]},
				RefColumns: []*schema.Column{ChatRoomsColumns[0]},
				OnDelete:   schema.NoAction,
			},
			{
				Symbol:     "chats_profiles_chats",
				Columns:    []*schema.Column{ChatsColumns[10]},
				RefColumns: []*schema.Column{ProfilesColumns[0]},
				OnDelete:   schema.NoAction,
			},
		},
	}
	// ChatRoomsColumns holds the columns for the "chat_rooms" table.
	ChatRoomsColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt, Increment: true},
		{Name: "room_name", Type: field.TypeString},
		{Name: "created_at", Type: field.TypeTime},
		{Name: "updated_at", Type: field.TypeTime},
		{Name: "deleted_at", Type: field.TypeTime, Nullable: true},
		{Name: "post_chat_rooms", Type: field.TypeInt, Nullable: true},
	}
	// ChatRoomsTable holds the schema information for the "chat_rooms" table.
	ChatRoomsTable = &schema.Table{
		Name:       "chat_rooms",
		Columns:    ChatRoomsColumns,
		PrimaryKey: []*schema.Column{ChatRoomsColumns[0]},
		ForeignKeys: []*schema.ForeignKey{
			{
				Symbol:     "chat_rooms_posts_chat_rooms",
				Columns:    []*schema.Column{ChatRoomsColumns[5]},
				RefColumns: []*schema.Column{PostsColumns[0]},
				OnDelete:   schema.SetNull,
			},
		},
	}
	// PostsColumns holds the columns for the "posts" table.
	PostsColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt, Increment: true},
		{Name: "image", Type: field.TypeString},
		{Name: "content", Type: field.TypeString, Size: 2147483647},
		{Name: "profile_displayname", Type: field.TypeString},
		{Name: "profile_birth_year", Type: field.TypeInt16, Nullable: true},
		{Name: "profile_gender", Type: field.TypeString, Nullable: true},
		{Name: "coordinates", Type: field.TypeOther, SchemaType: map[string]string{"mysql": "POINT"}},
		{Name: "created_at", Type: field.TypeTime},
		{Name: "updated_at", Type: field.TypeTime},
		{Name: "deleted_at", Type: field.TypeTime, Nullable: true},
		{Name: "reply_to", Type: field.TypeInt, Nullable: true},
		{Name: "profile_posts", Type: field.TypeInt},
	}
	// PostsTable holds the schema information for the "posts" table.
	PostsTable = &schema.Table{
		Name:       "posts",
		Columns:    PostsColumns,
		PrimaryKey: []*schema.Column{PostsColumns[0]},
		ForeignKeys: []*schema.ForeignKey{
			{
				Symbol:     "posts_posts_replies",
				Columns:    []*schema.Column{PostsColumns[10]},
				RefColumns: []*schema.Column{PostsColumns[0]},
				OnDelete:   schema.SetNull,
			},
			{
				Symbol:     "posts_profiles_posts",
				Columns:    []*schema.Column{PostsColumns[11]},
				RefColumns: []*schema.Column{ProfilesColumns[0]},
				OnDelete:   schema.NoAction,
			},
		},
	}
	// ProfilesColumns holds the columns for the "profiles" table.
	ProfilesColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt, Increment: true},
		{Name: "phone_number", Type: field.TypeString, Nullable: true},
		{Name: "device_id", Type: field.TypeString},
		{Name: "displayname", Type: field.TypeString},
		{Name: "password", Type: field.TypeString, Nullable: true},
		{Name: "birth_year", Type: field.TypeInt16, Nullable: true},
		{Name: "gender", Type: field.TypeString, Nullable: true},
		{Name: "created_at", Type: field.TypeTime},
		{Name: "updated_at", Type: field.TypeTime},
		{Name: "deleted_at", Type: field.TypeTime, Nullable: true},
	}
	// ProfilesTable holds the schema information for the "profiles" table.
	ProfilesTable = &schema.Table{
		Name:       "profiles",
		Columns:    ProfilesColumns,
		PrimaryKey: []*schema.Column{ProfilesColumns[0]},
	}
	// ProfileChatRoomsColumns holds the columns for the "profile_chat_rooms" table.
	ProfileChatRoomsColumns = []*schema.Column{
		{Name: "profile_id", Type: field.TypeInt},
		{Name: "chat_room_id", Type: field.TypeInt},
	}
	// ProfileChatRoomsTable holds the schema information for the "profile_chat_rooms" table.
	ProfileChatRoomsTable = &schema.Table{
		Name:       "profile_chat_rooms",
		Columns:    ProfileChatRoomsColumns,
		PrimaryKey: []*schema.Column{ProfileChatRoomsColumns[0], ProfileChatRoomsColumns[1]},
		ForeignKeys: []*schema.ForeignKey{
			{
				Symbol:     "profile_chat_rooms_profile_id",
				Columns:    []*schema.Column{ProfileChatRoomsColumns[0]},
				RefColumns: []*schema.Column{ProfilesColumns[0]},
				OnDelete:   schema.Cascade,
			},
			{
				Symbol:     "profile_chat_rooms_chat_room_id",
				Columns:    []*schema.Column{ProfileChatRoomsColumns[1]},
				RefColumns: []*schema.Column{ChatRoomsColumns[0]},
				OnDelete:   schema.Cascade,
			},
		},
	}
	// ProfileLikesColumns holds the columns for the "profile_likes" table.
	ProfileLikesColumns = []*schema.Column{
		{Name: "profile_id", Type: field.TypeInt},
		{Name: "post_id", Type: field.TypeInt},
	}
	// ProfileLikesTable holds the schema information for the "profile_likes" table.
	ProfileLikesTable = &schema.Table{
		Name:       "profile_likes",
		Columns:    ProfileLikesColumns,
		PrimaryKey: []*schema.Column{ProfileLikesColumns[0], ProfileLikesColumns[1]},
		ForeignKeys: []*schema.ForeignKey{
			{
				Symbol:     "profile_likes_profile_id",
				Columns:    []*schema.Column{ProfileLikesColumns[0]},
				RefColumns: []*schema.Column{ProfilesColumns[0]},
				OnDelete:   schema.Cascade,
			},
			{
				Symbol:     "profile_likes_post_id",
				Columns:    []*schema.Column{ProfileLikesColumns[1]},
				RefColumns: []*schema.Column{PostsColumns[0]},
				OnDelete:   schema.Cascade,
			},
		},
	}
	// Tables holds all the tables in the schema.
	Tables = []*schema.Table{
		ChatsTable,
		ChatRoomsTable,
		PostsTable,
		ProfilesTable,
		ProfileChatRoomsTable,
		ProfileLikesTable,
	}
)

func init() {
	ChatsTable.ForeignKeys[0].RefTable = ChatsTable
	ChatsTable.ForeignKeys[1].RefTable = ChatRoomsTable
	ChatsTable.ForeignKeys[2].RefTable = ProfilesTable
	ChatRoomsTable.ForeignKeys[0].RefTable = PostsTable
	PostsTable.ForeignKeys[0].RefTable = PostsTable
	PostsTable.ForeignKeys[1].RefTable = ProfilesTable
	ProfileChatRoomsTable.ForeignKeys[0].RefTable = ProfilesTable
	ProfileChatRoomsTable.ForeignKeys[1].RefTable = ChatRoomsTable
	ProfileLikesTable.ForeignKeys[0].RefTable = ProfilesTable
	ProfileLikesTable.ForeignKeys[1].RefTable = PostsTable
}
